import create from "../../../../services/blocking/create.js";
import define from "../../define.js";
import { ApiError } from "../../error.js";
import { getUser } from "../../common/getters.js";
import { Blockings, NoteWatchings, Users } from "../../../../models/index.js";
import { HOUR } from "../../../../const.js";
import { getGroupActor } from "../../common/get-group-actor.js";
export const meta = {
    tags: [
        "account"
    ],
    limit: {
        duration: HOUR,
        max: 100
    },
    requireCredential: true,
    kind: "write:blocks",
    errors: {
        noSuchUser: {
            message: "No such user.",
            code: "NO_SUCH_USER",
            id: "7cc4f851-e2f1-4621-9633-ec9e1d00c01e"
        },
        blockeeIsYourself: {
            message: "Blockee is yourself.",
            code: "BLOCKEE_IS_YOURSELF",
            id: "88b19138-f28d-42c0-8499-6a31bbd0fdc6"
        },
        alreadyBlocking: {
            message: "You are already blocking that user.",
            code: "ALREADY_BLOCKING",
            id: "787fed64-acb9-464a-82eb-afbd745b9614"
        },
        noSuchGroup: {
            message: "No such group.",
            code: "NO_SUCH_GROUP",
            id: "8193cd43-8319-4383-9591-a093cbb4aa3a"
        }
    },
    res: {
        type: "object",
        optional: false,
        nullable: false,
        ref: "UserDetailedNotMe"
    }
};
export const paramDef = {
    type: "object",
    properties: {
        userId: {
            type: "string",
            format: "misskey:id"
        },
        groupId: {
            type: "string",
            format: "misskey:id",
            nullable: true
        }
    },
    required: [
        "userId"
    ]
};
export default define(meta, paramDef, async (ps, user)=>{
    const blocker = await Users.findOneByOrFail({
        id: user.id
    });
    const group = await getGroupActor(ps.groupId, user);
    if (ps.groupId != null && group == null) throw new ApiError(meta.errors.noSuchGroup);
    // 自分自身
    if (group == null && user.id === ps.userId) {
        throw new ApiError(meta.errors.blockeeIsYourself);
    }
    // Get blockee
    const blockee = await getUser(ps.userId).catch((e)=>{
        if (e.id === "15348ddd-432d-49c2-8a5a-8069753becff") throw new ApiError(meta.errors.noSuchUser);
        throw e;
    });
    // Check if already blocking
    const exist = await Blockings.exist({
        where: {
            blockeeId: blockee.id,
            ...group ? {
                groupId: group.id
            } : {
                blockerId: blocker.id,
                groupId: null
            }
        }
    });
    if (exist) {
        throw new ApiError(meta.errors.alreadyBlocking);
    }
    await create(blocker, blockee, group?.id ?? null);
    if (group == null) {
        NoteWatchings.delete({
            userId: blocker.id,
            noteUserId: blockee.id
        });
    }
    return await Users.pack(blockee.id, blocker, {
        detail: true
    });
});
